FORMATS=graphml gexf dot

default: run diff clean

run: FORCE
	@for f in $(FORMATS); do \
	  $(EXEC) graph -format $$f test.jar > result.$$f; \
	done

diff: FORCE
	@mv result.gexf result.old
	@cat result.old | sed 's/ lastmodifieddate=".*"//' > result.gexf
	@for f in $(FORMATS); do \
	  diff -q result.$$f reference.$$f; \
	done

clean: FORCE
	@rm -f result.*

FORCE:
